<?php
namespace Sites\Amateur;

function get_shortname()
{
    return 'am';
}

function fetch_json($url) {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_TIMEOUT, 30);
    $raw = curl_exec($ch);
    if (curl_errno($ch)) {
        echo "ERR: Failed to fetch data from the API. URL: $url. Error: " . curl_error($ch) . "\n";
        curl_close($ch);
        return null;
    }
    curl_close($ch);
    return json_decode($raw, true);
}

function online_status() {
    global $_AVOS;

    $api_key = $_AVOS['config']['webcams']['MyFreeCams']['api_key'];
    $basic_api_url = "https://api.a00s.net/v3/cache/affiliates/camsfeed/json?a=$api_key&lang=en&wl=www.amateur.tv";
    $details_api_url = "https://api.a00s.net/v3/cache/affiliates/camapi/json?a=$api_key&lang=en&wl=www.amateur.tv&camname=";

    $basic_data = fetch_json($basic_api_url);
    if (!$basic_data || $basic_data['result'] !== 'OK') {
        echo "ERR: Invalid response from basic API.\n";
        return [];
    }

    $models = [];
    foreach ($basic_data['body'] as $model) {
        $details_url = $details_api_url . urlencode($model['username']);
        $details_data = fetch_json($details_url);

        if ($details_data && $details_data['result'] === 'OK') {
            $details = $details_data['body'];
            $models[] = [
                'site'          => 'am',
                'nickname'      => $model['username'],
                'name'          => isset($details['username']) ? \Avos\Utils\convert_ascii($details['username']) : '',
                'imageUrl'      => $details['profilePicture'] ?? '',
                'viewers'       => (int)($model['viewers'] ?? 0),
                'followers'     => (int)($details['followers'] ?? 0),
                'age'           => (int)($model['age'] ?? 0),
                'birthday'      => '', // Replace if available
                'languages'     => isset($details['languages']) ? \Avos\Utils\convert_ascii(iconv('UTF-8', 'ASCII//TRANSLIT', (string)$details['languages'])) : '',
                'location'      => isset($details['location']) ? \Avos\Utils\convert_ascii((string)$details['location']) : '',
                'tags'          => $model['tagsOnline'] ?? '',
                'subject'       => $model['topic'] ?? '',
                'earnedForGoal' => 0, // Replace with actual value if available
                'neededForGoal' => 0, // Replace with actual value if available
                'broadcastVR'   => 0, // Replace with actual value if available
                'gender'        => isset($details['genre']) ? str_replace(
                    ['Woman', 'Man', 'Couple', 'Trans', 'tsexual', 'Transsexual', 'Transsexual'],
                    ['f', 'm', 'c', 't', 't', 't', 't'],
                    (string)$details['genre']
                ) : '',
                'hd'            => 0, // Replace with actual value if available
                'status'        => 'f', // Default status, replace if needed
            ];
        } else {
            echo "ERR: Invalid response for model {$model['username']}.\n";
        }
    }

    print_r($models);
    return $models;
}

// Example usage
//$models = online_status();
//print_r($models);

