<?php

namespace Sites\Flirt4Free;

#http://www.flirt4free.com/geoimages/samples/1035762/GKFD/3571828.jpg
#https://live-screencaps.vscdns.com/1035762-desktop.jpg

function get_shortname()
{
	return 'ff';
}

function online_status()
{
    global $_AVOS;

    $url = 'https://www.flirt4free.com/webservices/performers.php?method=getLiveModels&data_type=xml&service=all&api_key=' . $_AVOS['config']['webcams']['Flirt4Free']['api_key'];

    if (!empty($_AVOS['config']['webcams']['Flirt4Free']['mp_code'])) {
        $url .= '&mp_code=' . $_AVOS['config']['webcams']['Flirt4Free']['mp_code'];
    }

    $raw = @file_get_contents($url);

    if ($raw === false) {
        echo "Failed to fetch data from URL: $url\n";
        return false;
    }

    // Check if the fetched content is valid XML
    libxml_use_internal_errors(true);
    $xml = simplexml_load_string($raw);

    if ($xml === false) {
        echo "Failed to parse XML: ";
        foreach (libxml_get_errors() as $error) {
            echo $error->message . "\n";
        }
        libxml_clear_errors();
        return false;
    }

    $models = array();

    if (!isset($xml->girls)) {
        if (isset($xml->description)) {
            echo "ERR: " . (string)$xml->description . "\n";
        }
        return false;
    }

    $status_map = array(
        'In Open' => 'f',
        'In Private' => 'p',
        'On Break' => 'a'
    );

    foreach (array('girls', 'guys') as $gender) {
        $g = ($gender == 'girls') ? 'f' : 'm';
        foreach ($xml->$gender->models->model as $m) {
            $tags = array();
            foreach ($m->categories->category as $c) {
                $tags[] = (string)$c->name;
            }
            $models[] = array(
                'site' => 'ff',
                'externalId' => (int)$m->id,
                'nickname' => \Avos\Utils\urlsafe(strtolower((string)$m->name), '_'),
                'name' => (string)$m->name,
                'gender' => $g,
                'imageUrl' => (string)$m->screencap_image,
                'earnedForGoal' => 0, // Replace with actual value if available
                'neededForGoal' => 0, // Replace with actual value if available
                'broadcastVR' => 0 ,// Replace with actual value if available
                'tags' => implode(',', $tags),
                'status' => $status_map[(string)$m->room_status]
            );
        }
    }

    return $models;
}

function get_model($m)
{
    global $_AVOS;

    $id = $m['externalId'];

    $url = 'https://www.flirt4free.com/webservices/performers.php?method=getModelInfo&data_type=xml' . 
           '&api_key=' .  $_AVOS['config']['webcams']['Flirt4Free']['api_key'] . 
           '&mp_code=' .  $_AVOS['config']['webcams']['Flirt4Free']['mp_code'] .
           '&model_id=' . $id;

    $raw = @file_get_contents($url);
    $xml = \simplexml_load_string($raw);

    if ($xml === false) {
        return null; // Return null if there's an error parsing XML
    }

    $model = array('age' => 0);

    if (isset($xml->model->birthdate) && preg_match('!(\d\d\d\d)\-(\d\d)\-(\d\d)!', (string)$xml->model->birthdate, $c)) {
        $birthday = mktime(0, 0, 0, $c[2], $c[3], $c[1]);
        $now = time();
        $model['age'] = (int)(($now - $birthday)/31536000);
        if ($model['age'] > 99) {
            $model['age'] = 0;
        }
    }

    // Check if properties exist before accessing them
    $model['height'] = isset($xml->model->height_cm) ? (int)$xml->model->height_cm : 0;
    $model['weight'] = isset($xml->model->weight_kg) ? (int)$xml->model->weight_kg : 0;
    $model['cup_size'] = isset($xml->model->cup_size) ? (string)$xml->model->cup_size : '';
    $model['eye_color'] = isset($xml->model->eye_color) ? (string)$xml->model->eye_color : '';
    $model['hair_color'] = isset($xml->model->hair_color) ? (string)$xml->model->hair_color : '';
    $model['hair_length'] = isset($xml->model->hair_length) ? (string)$xml->model->hair_length : '';
    $model['ethnicity'] = isset($xml->model->ethnicity) ? (string)$xml->model->ethnicity : '';
    $model['body_type'] = isset($xml->model->body_type) ? (string)$xml->model->body_type : '';
    $model['body_mods'] = isset($xml->model->body_mods) ? (string)$xml->model->body_mods : '';
    $model['pubic_hair'] = isset($xml->model->pubic_hair) ? (string)$xml->model->pubic_hair : '';

    return $model;
}
