<?php
include('bootstrap.php');

// Define the absolute path for the output file
$filename = __DIR__ . '/unpublished_models.txt';

// Try to open the file for writing
$file = @fopen($filename, 'w');

// Check if the file was opened successfully
if ($file === false) {
    die("Error opening the file $filename. Please check directory permissions and path.\n");
}

// Execute the query to get unpublished models
$unpublishedModels = \Avos\Database\queryList(
    "SELECT nickname FROM webcamsArchive WHERE updatedOn = 0;"
);

// Debug: Print out the raw result of the query to verify
echo "Raw data from query:\n";
var_dump($unpublishedModels);

// Collect the nicknames
$nicknames = [];

// Check if $unpublishedModels is an array
if (is_array($unpublishedModels)) {
    foreach ($unpublishedModels as $model) {
        // If $model is a string, treat it as a nickname
        if (is_string($model)) {
            $nickname = trim($model);
            if (!empty($nickname)) {
                $nicknames[] = $nickname;
            }
        } else {
            echo "Warning: Unexpected data format.\n";
            var_dump($model);
        }
    }
} else {
    echo "Warning: The query did not return an array.\n";
}

// Debug: Print out the collected nicknames to verify
echo "Collected nicknames:\n";
var_dump($nicknames);

// Remove duplicates from the nicknames array
$uniqueNicknames = array_unique($nicknames);

// Sort nicknames (optional)
sort($uniqueNicknames);

// Write nicknames to the file as a comma-separated list
if (count($uniqueNicknames) === 0) {
    fwrite($file, "No unpublished models found.\n");
} else {
    $nicknameList = implode(',', $uniqueNicknames);
    fwrite($file, $nicknameList . "\n");
}

// Close the file
fclose($file);

// Count the number of unique nicknames
$numModels = count($uniqueNicknames);

// Echo the result with the count of models
echo "Unpublished models have been written to $filename. Number of unpublished models: $numModels\n";
