#!/bin/bash

webroot=web

pushd ../.. > /dev/null

if [[ ! -e avos ]];
then
	echo "must be run from avos/bin/"
	exit
fi

date=$(date +"%y%m%d")
tmp=$(/tmp/avos.release.$$)

##
## main avos files
##

tar czf avos/releases/avos-$date.tgz --exclude=avos/bin/config.ini avos/bin/ avos/lib/ avos/setup/ avos/templates.admin/ avos/templates.example/ 

cp $PWD/avos/releases/avos-$date.tgz $PWD/$webroot/
echo "$PWD/avos/releases/avos-$date.tgz"

##
## web and admin
##

tar czf avos/releases/avos-$date-web.tgz web/index.php web/.htaccess web/admin/

cp $PWD/avos/releases/avos-$date-web.tgz $PWD/$webroot/
echo "$PWD/avos/releases/avos-$date-web.tgz"
