<?php
namespace Sites\Chaturbate;
function get_shortname()
{
	return 'cb';
}

function online_status()
{
	global $_AVOS;

	$url = 'https://chaturbate.com/affiliates/api/onlinerooms/?format=xml&wm=' . $_AVOS['config']['webcams']['Chaturbate']['affiliate'];

	$raw = @file_get_contents($url);
	$xml = simplexml_load_string($raw);
	$models = array();

	if (!isset($xml->resource)) {
		if (isset($xml->description)) {
			echo "ERR: " . (string)$xml->description . "\n";
		}
		return $models;
	}

	// gender: c, f, m, s
	// only add model if female or couple or have more than 5 viewers

	foreach ($xml->resource as $m) {
		if (strpos((string)$m->gender, "fc") !== false || (int)$m->num_users > 5) {
			#echo "FISH2 " . (string)$m->gender . " " . (string)$m->username . " " . (string)$m->num_users . "\n";
			$models[] = array(
				'site'			=> 'cb',
				'nickname' 		=> (string)$m->username,
				'name' 			=> \Avos\Utils\convert_ascii((string)$m->display_name),
				'imageUrl'		=> (string)$m->image_url,
				'viewers'		=> (int)$m->num_users,
				'followers'		=> (int)$m->num_followers,
				'age'			=> (string)$m->age,
				'birthday'		=> (string)$m->birthday,
                'languages'		=> \Avos\Utils\convert_ascii(iconv('UTF-8', 'ASCII//TRANSLIT', (string)$m->spoken_languages)),
				'location'		=> \Avos\Utils\convert_ascii((string)$m->location),
				'tags' 			=> implode(',', (array)$m->tags->resource),
				'subject'		=> \Avos\Utils\convert_ascii((string)$m->room_subject),
                'earnedForGoal' => 0, // Replace with actual value if available
                'neededForGoal' => 0, // Replace with actual value if available
                'broadcastVR' => 0 ,// Replace with actual value if available
				'gender'		=> str_replace(
									array('c', 'f', 'm', 't', 's', 'tf', 'tm', 'tn'),
									array('c', 'f', 'm', 't', 't', 't',  't',  't'),
									(string)$m->gender
								),

				'hd'	 		=> (int)str_replace(
									array('True', 'False'),
									array(1, 0),
									(string)$m->is_hd
								),

				'status'	 	=> str_replace(
									array('public', 'private', 'away', 'hidden'),
									array('f', 'p', 'a', 'g'),
									(string)$m->current_show
								)
                            );
		}
	}

	return($models);
}


/*
//second api
function updateChaturbateDataForModels()
{
    $oldest = time() - getConfig('webcams', 'scrapeInterval', 30) * 86400;
    
    // Log a debug message to indicate the start of the function
    error_log("Chaturbate Data Update: Starting...");

    // Fetch models from the database with a status other than offline
    $models = \Avos\Database\queryAssoc("SELECT id, nickname FROM webcams WHERE scrapedOn < $oldest AND site='cb' AND status != 'o'");
    
    // Log the total number of models found
    error_log("Total models to process: " . count($models));

    foreach ($models as $i => $m) {
        // Log a debug message for each model being processed
        error_log("Processing model: " . $m['nickname']);

        // Fetch Chaturbate API data for the current model
        $chaturbateData = getChaturbateModelData($m['nickname']);

        if ($chaturbateData !== null) {
            // Log a debug message to indicate the update
            error_log("Updating model: " . $m['nickname']);
            
            // Update the model in the database with the Chaturbate API data
            \Avos\Database\updateModelWithChaturbateData($m['id'], $chaturbateData);
        } else {
            // Log a debug message if data is not available for the model
            error_log("Data not available for model: " . $m['nickname']);
        }
    }

    // Log a debug message to indicate the end of the function
    error_log("Chaturbate Data Update: Completed.");
}






function getChaturbateModelData($nickname)
{
    $newapiurl = "https://chaturbate.com/api/chatvideocontext/madeline_jackson/";

    $ch = curl_init($newapiurl);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.3');

    $raw = curl_exec($ch);

    if ($raw === false) {
        error_log("Error fetching data for $nickname: " . curl_error($ch));
        return null;
    }

    curl_close($ch);

    $data = json_decode($raw, true);

    // Log the API response for debugging
    error_log("API Response for $nickname: " . json_encode($data));

    if ($data !== null && isset($data['allow_private_shows'])) {
        $privateShowPrice = $data['private_show_price'];

        // Include other fields as needed

        return [
            'private_show_price' => $privateShowPrice,
            // Include other fields as needed
        ];
    } else {
        error_log("Data not available for model: $nickname");
        return null;
    }
}

// Specify the model you want to fetch data for
$desiredModel = "madeline_jackson";
$oldest = time() - getConfig('webcams', 'scrapeInterval', 30) * 86400;
// Fetch models from the database with a status other than offline
$models = \Avos\Database\queryAssoc("SELECT nickname FROM webcams WHERE status != 'o' and gender != 'm' " );

foreach ($models as $i => $m) {
    // Log a debug message for each model being processed
    error_log("Processing model: " . $m['nickname']);

    // Fetch Chaturbate API data for the current model
    $chaturbateData = getChaturbateModelData($m['nickname']);

    if ($chaturbateData !== null) {
        // Log a debug message to indicate the update
        error_log("Updating model: " . $m['nickname']);

        // Update the model in the database with the Chaturbate API data
        \Avos\Database\updateModelWithChaturbateData($m['id'], $chaturbateData);

        // If the desired model is found, break out of the loop
        if ($m['nickname'] === $desiredModel) {
            break;
        }
    } else {
        // Log a debug message if data is not available for the model
        error_log("Data not available for model: " . $m['nickname']);
    }
}

// Log a debug message to indicate the end of the function
error_log("Chaturbate Data Update: Completed.");



function runChaturbateDataUpdateCron() {
    // Call the function to update Chaturbate data for models
    updateChaturbateDataForModels();
}


*/

///// scrape cb some bugs 
function scrape_models($num, $min, $max)
{
    \Avos\Cron\debug("scraping max $num models");

   $oldest = time() - getConfig('webcams', 'scrapeInterval', 30) * 86400;
  
    $models = \Avos\Database\queryAssoc("SELECT id, nickname FROM webcams WHERE scrapedOn < $oldest AND site='cb' ORDER BY updatedOn DESC LIMIT $num");

    foreach ($models as $i => $m) {

        $rm = array('id' => $m['id']);
        $html = file_get_contents("https://www.chaturbate.com/$m[nickname]/");

        //
        // missing attributes from feed
        //

        preg_match_all('!<div class="attribute">\s*(<div class="label">(.+?):</div>\s*<div class="data">(.*?)</div>)!', $html, $c);
        $attr = array();

        foreach ($c[2] as $i => $name) {
            $attr[$name] = html_entity_decode($c[3][$i]);
            $attr[$name] = iconv('UTF-8', 'ASCII//TRANSLIT', $c[3][$i]);
        }

        if (!empty($attr['Body Type'])) {
            $rm['body'] = substr($attr['Body Type'], 0, 32);
        }

        if (!empty($attr['Birth Date'])) {
            $rm['birthday'] = strtotime($attr['Birth Date']);

            if ($rm['birthday'] < 0 || $rm['birthday'] == '') {
                unset($rm['birthday']);
            }
        }


        preg_match_all('!<a href="/external_link/\?url=(.*?)"!', $html, $u);
        $links = array();

        foreach ($u[1] as $v) {
            if (!preg_match('!dmca!i', $v)) {
                $links[] = urldecode($v);
            }
        }

        if (count($links) > 0) {
            $rm['links'] = serialize($links);
        }

        if (count($rm) > 1) {
            $sql = "UPDATE webcams SET ";
            foreach ($rm as $k => $v) {
                if ($k != 'id') {
                    $sql .= $k . '=' . \Avos\Database\quote($v) . ',';
                }
            }
            $sql .= "scrapedOn=UNIX_TIMESTAMP() WHERE id=$rm[id]";
            \Avos\Cron\debug($sql);
            \Avos\Database\query($sql);

            $sql = str_replace('UPDATE webcams', 'UPDATE webcamsArchive', $sql);
            \Avos\Database\query($sql);
        }

        sleep(rand(15, 30));
    }
}












