<?php

namespace Sites\StripChat;

##
## [profileBirthDate] => 1999-04-25
## [profileSpecifics] => Array ( [0] => specificsBigTits [1] => specificsBigAss [2] => specificShaven [3] => specificSmallTits)
## [profileEthnicity] => ethnicityWhite
## [profileHairColor] => hairColorBlonde
## [profileEyesColor] => eyeColorGreen
## [profileSubculture] => subcultureRomantic, subcultureHousewives
## [broadcastInteractiveToy] => Array ( [0] => lovense)
## [profileBodyType] => bodyTypeAverage
## [modelsCountry] => MX, IN, ...
##
## \Avos\Utils\countryCode('united states')
##

function get_shortname()
{
    return 'sc';
}

function online_status()
{
	global $_AVOS;

	$url = "https://go.xxxijmp.com/api/models?limit=10000&fields=tags,geobans";

	$raw = @file_get_contents($url);
	$json = json_decode($raw);
    $models = array();

	$gender_map = array(
					"male" => 'm', 
					"female" => 'f', 
					"tranny" => 't', 
					"maleFemale" => 'c', 
					"males" => 'c', 
					"females" => 'c', 
					"trannies" => 't', 
					"maleTranny" => 't', 
					"femaleTranny" => 't',
					"" => ''
				);

    foreach ($json->models as $m) {
		$gender = empty($m->gender) ? '' : $gender_map[ $m->gender ];

		if (!empty($m->gender) && !($gender == 'm' && (int)$m->viewersCount < 6)) {

			$age = 0;
			if (isset($m->profileBirthDate) && preg_match('!(\d\d\d\d)\-(\d\d)\-(\d\d)!', (string)$m->profileBirthDate, $c)) {
				$birthday = mktime(0, 0, 0, $c[2], $c[3], $c[1]);
				$now = time();
				$age = (int)(($now - $birthday)/31536000);
				if ($age > 99) {
					$age = 0;
				}
            }

            $birthday = '';
            if (!empty($m->profileBirthDate)) {
                $birthday = $m->profileBirthDate;
            }

            $body = '';
            if (!empty($m->profileBodyType)) {
                $body = str_replace('bodyType', '', $m->profileBodyType);
            }

            $languages = array();
            foreach ($m->languages as $l) {
                $languages[] = \Avos\Utils\languageCode($l);
            }

            //
            // blocked countries and regions
            //

            $blocked = [];

            if (!empty($m->geobans)) {

                if (isset($m->geobans->blockedCountries)) {
                    foreach ($m->geobans->blockedCountries as $c) {
                        $blocked[$c] = 1;
                    }

                    foreach ($m->geobans->blockedRegions as $c => $r) {
                        $blocked[$c] = 1;
                    }
                }
            }

            $blocked = array_keys($blocked);

            //
            // add the model
            //

			$models[] = array(
				'site' => 'sc',
				'nickname' => $m->username,
				'name' => $m->username,
				'imageUrl' => isset($m->snapshotUrl) ? $m->snapshotUrl : '',
				'streamUrl' => $m->stream->url,
				'profileImageUrl' => $m->previewUrlThumbBig,
				'viewers' => (int)$m->viewersCount,
				'followers' => (int)$m->favoritedCount,
				'age' => $age,
				'tags' => get_tags($m->tags),
                'subject' => isset($m->goalMessage) ? $m->goalMessage : "",
                'birthday' => $birthday,
                'body' => $body,
                'languages' => implode(',', $languages),
                'location' => isset($m->modelsCountry) ? \Avos\Utils\countryCode($m->modelsCountry) : '',

				'gender' => $gender_map[ $m->gender ],

                'hd' => isset($m->broadcastHD) && $m->broadcastHD == 1 ? 1 : 0,

                'blocked' => $blocked,

				'status' => str_replace(
								array('public', 'private', 'groupShow', 'p2p', 'virtualPrivate'),
								array('f', 'p', 'g', 'p', 'p'),
								$m->status)[0]
			);
        }

    }

	return $models;
}

function get_tags($tags)
{
	$ret = array();

	if (!is_array($tags)) {
		return '';
	}

	foreach($tags as $t) {
		if (preg_match('!.*\/(.+)!', $t, $c)) {
			$ret[] = $c[1];
		}
		else {
			$ret[] = $t;
		}
	}

	$ret = implode(',', $ret);
	return $ret;
}






	/*
		$model['photo'] = $model['profile_images']['profile_image'];
		$model['thumb'] = $model['profile_images']['thumbnail_image_medium'];
		$model['snapshot'] = $model['profile_images']['thumbnail_image_big_live'];
		$photos = array(array(time(), str_replace('http://', '', $model['profile_images']['thumbnail_image_big_live'])));

		//
		// height
		//

		if (preg_match('/(\d+)(\'(\d+))?.*?(\d+)(\'(\d+))?/', $model['height'], $cap))
		{
			$model['height'] = (integer)(($cap[1] * 12 + $cap[3] + $cap[4] * 12 + $cap[6]) / 2 + 0.5);
		}
		else {
			$model['height'] = '';
		}

		//
		// weight
		//

		if (preg_match('/(\d+) \- (\d+) lbs/', $model['weight'], $cap))
		{
			$model['weight'] = (integer)(($cap[1] + $cap[2]) / 2 + 0.5);
		}
		else {
			$model['weight'] = '';
		}

		//
		// language
		//

		$model['language'] = array();
		$model['language'][] = strtolower((string)$model['primary_language_key']);
		if (!empty($model['secondary_language_key'])) {
			$model['language'][] = strtolower((string)$model['secondary_language_key']);
		}

		//
		// normalize
		//

		$model['gender'] = zestoi_webcams_normalize($model['gender'], $gender_map);
		$model['ethnicity'] = zestoi_webcams_normalize($model['ethnicity'], $ethnicity_map);
		$model['hair_color'] = zestoi_webcams_normalize($model['hair_color'], $haircolor_map);
		$model['eye_color'] = zestoi_webcams_normalize($model['eye_color'], $eyecolor_map);
		$model['chat_status'] = zestoi_webcams_normalize($model['chat_status'], $status_map);
		$model['category'] = zestoi_webcams_normalize($model['gender'], $category_map);

		if ($model['gender'] == 'f' || $model['gender'] == 'mf') {
			$model['cup_size'] = zestoi_webcams_normalize($model['bust_penis_size'], $cupsize_map);
		}
		else {
			$model['penis_size'] = $model['bust_penis_size'];
		}

		#print_r($model);exit;
		#$foo[$model['bust_penis_size']] = 1;
		
		$models[] = array('attribs' => $model, 'photos' => $photos);
		*/

