<?
#$start = microtime(true);

// to reduce data size delete this from all epoch times before storing
define('EPOCHSTART', 1630000000);

//
// the user defines TOP in config.php as the "avos" folder
//

include("config.php");

ob_start();
session_start();

if (1) {
	ini_set('display_errors', 1);
	ini_set('display_startup_errors', 1);
	error_reporting(E_ALL);
}
else {
	ini_set('display_errors', 'Off');
	error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING);
}

date_default_timezone_set('Europe/Bucharest');

define('DEBUG', FALSE);
#define('DEBUG', TRUE);
define('TOPURL', '');
define('BIN', TOP . 'bin/');
define('URL', str_replace('//', '/', dirname($_SERVER['SCRIPT_NAME']) . '/'));
define('LIB', TOP . 'lib/');
define('TEMPLATES', TOP . 'templates/');

$AUTH = isset($_SESSION['username']) ? true : false;

//
// read in site config and define mysql connection info
//

$_AVOS['config'] = parse_ini_file(BIN . 'config.ini', true);

define('DB_HOST', $_AVOS['config']['mysql']['hostname']);
define('DB_USER', $_AVOS['config']['mysql']['username']);
define('DB_PASS', $_AVOS['config']['mysql']['password']);
define('DB_NAME', $_AVOS['config']['mysql']['database']);

//
// connect to redis
//

if (!empty($_AVOS['config']['redis']['hostname'])) {
	$_AVOS['redis'] = new Redis();
	$_AVOS['redis']->connect($_AVOS['config']['redis']['hostname']);
	$_AVOS['redis']->setOption(Redis::OPT_SERIALIZER, Redis::SERIALIZER_PHP);
	$_AVOS['redis']->setOption(Redis::OPT_PREFIX, "");
}

require(LIB . "Avos/Utils.php");
require(LIB . "Avos/Scaffold.php");
require(LIB . "Avos/Routes.php");
require(LIB . "Avos/Redis.php");
require(LIB . "Avos/Database.php");
require(LIB . "Avos/Webcams.php");
#require(LIB . 'smarty/Smarty.class.php');

\Avos\Database\disableCache();

echo <<<MENU
<div>
	<a href="?page=summary">Summary</a> |
	<a href="?page=videos">Videos</a> |
	<a href="?page=webcams">Search</a>
</div>
MENU;

$page = isset($_GET['page']) ? $_GET['page'] : 'summary';

switch ($page) {
	case 'summary':
		summary();
		break;
	case 'videos':
		videos();
		break;
}

function summary()
{
$sites = \Avos\Database\queryAssoc("select site,max(updatedon) as updatedon from webcams group by site order by site");

echo "<h2>Webcams Last Update</h2>";

echo "<p>Server Time: " . date('d M Y H:i:s', time()) . "</p>";
echo "<table border=1>";
echo "<tr><th>Site</th><th>Last Status Updated</th></tr>";

foreach ($sites as $s) {
	$site = \Avos\Scaffold\expandSiteName($s['site']);
	$updatedon = date('d M Y H:i:s', $s['updatedon']);
	echo "<tr>";
	echo "<td>$site</td><td>$updatedon</td>";
	echo "</tr>";
}

echo "</table>";

$sites = \Avos\Database\queryAssoc("select site,status!='o' as status,count(*) as num from webcams group by site,status!='o' order by site asc");

echo "<h2>Webcams Online Status</h2>";
echo "<table border=1>";
echo "<tr><th>Site</th><th>Status</th><th>Count</th></tr>";

foreach ($sites as $s) {
	echo "<tr>";
	$status = $s['status'] == 1 ? 'Online' : 'Offline';
	$site = \Avos\Scaffold\expandSiteName($s['site']);
	echo "<td>$site</td><td>$status</td><td>$s[num]</td>";
	echo "</tr>";
}
echo "</table>";

$videos = \Avos\Database\queryAssoc("select processed, publishedon>0 as published,count(*) as num from videos group by processed,publishedon>0");

echo "<h2>Videos</h2>";
echo "<table border=1>";
echo "<tr><th>Processed</th><th>Published</th><th>Count</th></tr>";

foreach ($videos as $v) {
	$v['processed'] = $v['processed'] == 1 ? 'Yes' : 'No';
	$v['published'] = $v['published'] == 1 ? 'Yes' : 'No';
	echo "<tr>";
	echo "<td>$v[processed]</td><td>$v[published]</td><td>$v[num]</td>";
	echo "</tr>";
}

echo "</table>";
}

function videos()
{
if (isset($_GET['unpublish'])) {
	$id = (int)$_GET['unpublish'];
	\Avos\Database\query("update videos set publishedon=0 where id=$id");
}

if (isset($_GET['publish'])) {
	$id = (int)$_GET['publish'];
	\Avos\Database\query("update videos set publishedon=unix_timestamp() where id=$id");
}

$videos = \Avos\Database\queryAssoc("select id, title, views, processed, publishedon from videos order by publishedon desc, id desc");

echo "<h2>Videos</h2>";
echo "<table border=1>";
echo "<tr><th>Id</th><th>Processed</th><th>Published</th><th>Views</th><th>Title</th><th>Action</th></tr>";

foreach ($videos as $v) {
	$v['processed'] = $v['processed'] == 1 ? 'Yes' : 'No';

	if ($v['publishedon'] > 0) {
		$v['publishedonstr'] = date('d M Y H:i:s', $v['publishedon']);
	}
	else {
		$v['publishedonstr'] = 'No';
	}

	echo "<tr>";
	echo "<td>$v[id]</td>";
	echo "<td>$v[processed]</td><td>$v[publishedonstr]</td><td>$v[views]</td><td>$v[title]</td>";
	echo "<td><a href='?page=videos&" . (($v['publishedon'] > 0) ? 'unpublish' : 'publish') . "=$v[id]'>";
	echo ($v['publishedon'] > 0) ? 'Unpublish' : 'Publish';
	echo "</td>";
	echo "</tr>";
}

echo "</table>";
}
