<?php
session_start();
require 'vendor/autoload.php'; // Include PHPMailer

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

global $_AVOS;

// Check if database configuration is set
if (isset($_AVOS['config']['mysql'])) {
    // Get database configuration
    $db_host = $_AVOS['config']['mysql']['hostname'];
    $db_username = $_AVOS['config']['mysql']['username'];
    $db_password = $_AVOS['config']['mysql']['password'];
    $database = $_AVOS['config']['mysql']['database'];

    // Establish database connection
    $conn = new mysqli($db_host, $db_username, $db_password, $database);
    if ($conn->connect_error) {
        die("Connection failed: " . $conn->connect_error);
    }

    if ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_POST["submit"])) {
        $usernameOrEmail = $_POST["username_or_email"];

        // Check if the username or email exists in the database
        $stmt = $conn->prepare("SELECT id, email FROM member WHERE username = ? OR email = ?");
        $stmt->bind_param("ss", $usernameOrEmail, $usernameOrEmail);
        $stmt->execute();
        $result = $stmt->get_result();

        if ($result->num_rows === 0) {
            echo "Username or email not found.";
        } else {
            // Generate a reset token (a random string)
            $resetToken = bin2hex(random_bytes(32));

            // Store the reset token and associated email in the database
            $stmt = $conn->prepare("UPDATE member SET reset_token = ? WHERE username = ? OR email = ?");
$stmt->bind_param("sss", $resetToken, $usernameOrEmail, $usernameOrEmail);
if ($stmt->execute()) {
                // Send an email to the user with the reset link
                $to = $result->fetch_assoc()["email"];
                $subject = "Password Reset Link";
                $message = "Click the following link to reset your password:\n";
                $message .= $_AVOS['config']['site']['url'] . "change-password?token=" . $resetToken;

                // Send the email using PHPMailer
                $mail = new PHPMailer(true);

                

                try {
                    $message = "<html><body>";
                    $message .= '<div style="background-color:#cfe2ec;text-align:center;">';
                    $message .= '<br><br>';
                    $message .= '<div style="background:#fff;background-color:#fff;margin:0px auto;max-width:600px">';
                    $message .= '<br><br>';
                    $message .= '<h4 style="color: green;margin-top:10px">Hello there,</h4>';
                    $message .= "<p>We have received a request to reset the password for your account. To complete this process, please follow the instructions below:</p>";
                    $message .= "<ul style='list-style-type: none; padding: 0;'>";
                    $message .= "<li style='color: #008000;'>Click on the following link to reset your password:</li>";
                    $message .= '<li style="color: #008000;"><a href="' . $_AVOS['config']['site']['url'] . "change-password?token=" . $resetToken . '">Reset Password</a></li>';
                    $message .= "<li style='margin-bottom: 5px;color: #008000;'>(Note: If you cannot click the link, please copy and paste it into your browser's address bar.)</li>";
                    $message .= "</ul>";

                    $message .= "<p>You will be directed to a page where you can set a new password for your account.</p>";
                    $message .= "<p>After setting your new password, you will be able to log in with your updated credentials.</p>";
                    $message .= "<p>If you did not request a password reset, please disregard this email. Your account remains secure.</p>";
                    $message .= "<p>Thank you for choosing $userResetSiteName!</p>";
                    $message .= "<p>Best regards,</p>";
                    $message .= "<p>$userSuperAdminName from $userSuperAdminName </p>";
                   // $message .= "<p>[Your Company Name]</p>";
                   // $message .= "<p>[Contact Information]</p>";
                     
                    // Add your logo using the $headerLogoUrl variable as an <img> tag
                    $message .= '<img style="height: 50px;" src="' . $_AVOS['config']['site']['url'] . $headerLogoUrl . '" >';

                    $message .= '</div>';
                    $message .= '<br><br>';
                    $message .= '</div>';
                    $message .= '</body></html>';
                    $message .= "</body></html>";

                    
                    
                    $mail->isSMTP();
                    $mail->Host = 'smtp.gmail.com'; // Use Gmail's SMTP server
                    $mail->SMTPAuth = true;
                    $mail->Username = $userEmailSender; // Replace with your Gmail email address
                    $mail->Password = $userEmailSenderPass; // Replace with your Gmail password
                    $mail->SMTPSecure = 'tls';
                    $mail->Port = 587;
                
                    $mail->setFrom($userEmailSender, $userResetSiteName); // Replace with your name and Gmail email
                    $mail->addAddress($to);
                   // $mail->SMTPDebug = 2; // Enable verbose debugging output
                    //$mail->Debugoutput = 'html'; // Display debug output as HTML
                    $mail->isHTML(true);
                    $mail->Subject = $subject;
                    $mail->Body = $message;
                
                    $mail->send();
                    
                    echo "Password reset link has been sent to your email.";
                } catch (Exception $e) {
                    echo "Email sending failed: " . $mail->ErrorInfo;
                }
                
            } else {
                echo "Error updating reset token: " . $stmt->error;
            }

            $stmt->close();
        }
    }

    // Close the database connection
    $conn->close();
}
?>


   


    <center>



<div class="store-item mlr-neg-5 mt5" style="width:50%">
            <div class="col-right">
                <div class="text-center">
                    <!-- Login popup -->
                    <div class="well">
                        <h4>Reset Your Password</h4>
                        <p class="p-small" >Please double-check your information. You'll receive a password reset link at your registered email.</p>
                        <br>
                        <form method="POST" action="">
        <label for="username_or_email">Username or Email:</label>
        <input type="text" name="username_or_email" class="input-mfcs mt10" required><br>
        <br>
        <button type="submit" name="submit" class="btn btn-green" >Submit</button>
    </form>
                    </div>
                </div>
            </div>
        </div>
</center>  






</div>