<?php if (isset($model['site']) && $model['site'] != 'Streamate'): ?>
<script type="text/javascript">
google.charts.load('current', {'packages':['corechart', 'line']});
google.charts.setOnLoadCallback(drawChart2);

function drawChart2() {
    // followers
    var dataf = new google.visualization.DataTable();
    dataf.addColumn('date', 'Date');
    dataf.addColumn('number', 'Followers');

    dataf.addRows([
        <?php foreach ($ranks['epochTime'] as $i => $epochTime): 
            // Check if 'followers' array exists and is valid
            if (isset($ranks['followers']) && isset($ranks['followers'][$i]) && $ranks['followers'][$i] > 0) : ?>
            [new Date(<?= $epochTime * 1000 ?>), <?= $ranks['followers'][$i] ?>],
        <?php endif; endforeach; ?>
    ]);

    var optionsf = {
        title: 'Followers',
        backgroundColor: '<?= $chartcolor ?>',
        legendTextStyle: { color: '<?= $chartTextcolor ?>' },
        titleTextStyle: { color: '<?= $chartTextcolor ?>' },
        hAxis: {
            textStyle: { color: '<?= $chartTextcolor ?>' }
        },
        vAxis: {
            textStyle: { color: '<?= $chartTextcolor ?>' }
        }
    };

    var followers = new google.visualization.LineChart(document.getElementById('followerschart'));
    followers.draw(dataf, google.charts.Line.convertOptions(optionsf));

    // viewers
    var datav = new google.visualization.DataTable();
    datav.addColumn('date', 'Date');
    datav.addColumn('number', 'Viewers');

    datav.addRows([
        <?php foreach ($ranks['epochTime'] as $i => $epochTime): 
            // Check if 'viewers' array exists and is valid
            if (isset($ranks['viewers']) && isset($ranks['viewers'][$i]) && $ranks['viewers'][$i] > 0) : ?>
            [new Date(<?= $epochTime * 1000 ?>), <?= $ranks['viewers'][$i] ?>],
        <?php endif; endforeach; ?>
    ]);

    var optionsv = {
        title: 'Viewers',
        curveType: 'function',
        legend: { position: 'none' },
        backgroundColor: '<?= $chartcolor ?>',
        titleTextStyle: { color: '<?= $chartTextcolor ?>' },
        hAxis: { textStyle: { color: '<?= $chartTextcolor ?>' } },
        vAxis: { textStyle: { color: '<?= $chartTextcolor ?>' } }
    };

    var viewers = new google.visualization.ColumnChart(document.getElementById('viewerschart'));
    viewers.draw(datav, google.charts.Line.convertOptions(optionsv));

    // rank
    var datar = new google.visualization.DataTable();
    datar.addColumn('date', 'Date');
    datar.addColumn('number', '<?= $model['site'] ?> Rank');
    datar.addColumn('number', '<?= $model['site'] ?> Rank by Gender');

    datar.addRows([
        <?php foreach ($ranks['epochTime'] as $i => $epochTime): 
            // Check if 'rank' array exists and is valid
            if (isset($ranks['rank']) && isset($ranks['rank'][$i]) && $ranks['rank'][$i] > 0) : ?>
            [new Date(<?= $epochTime * 1000 ?>), <?= $ranks['rank'][$i] ?>, <?= isset($ranks['genderRank'][$i]) ? $ranks['genderRank'][$i] : 0 ?>],
        <?php endif; endforeach; ?>
    ]);

    var optionsr = {
        curveType: 'function',
        legend: { position: 'top' },
        backgroundColor: '<?= $chartcolor ?>',
        titleTextStyle: { color: '<?= $chartTextcolor ?>' },
        hAxis: { textStyle: { color: '<?= $chartTextcolor ?>' } },
        vAxis: { textStyle: { color: '<?= $chartTextcolor ?>' } }
    };

    var rank = new google.visualization.ColumnChart(document.getElementById('rankchart'));
    rank.draw(datar, google.charts.Line.convertOptions(optionsr));
}
</script>
<?php endif; ?>
