<script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/raphael/2.1.2/raphael-min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/morris.js/0.5.0/morris.min.js"></script>

<script type="text/javascript">
google.charts.load('current', {'packages':['corechart', 'timeline']});
google.charts.setOnLoadCallback(drawChart);

let isChartDrawn = false; // Variable to track if the chart has been drawn

function drawChart() {
    // Prepare data for the donut chart
    var values = [],
        labels = [],
        legends = true,
        legendsElement = $('#TicketByDepartmentLegends'),
        colors = ['orange','forestgreen','crimson','#e67157'];

    $("#TicketByDepartment tr").each(function () {
        values.push(parseInt($("td", this).text(), 10));
        labels.push($("th", this).text());
    });

    $("#TicketByDepartment").hide();
    var r = Raphael("DonutTicketsByDepartment", 200, 200);
    r.donutChart(100, 100, 88, 35, values, labels, colors, legends, legendsElement, colors);

    var width = document.getElementById('monthly_stats').offsetWidth;

    // Pie chart with monthly summary
    var data = google.visualization.arrayToDataTable([
        ['Status', 'Time'],
        ['Freechat', <?= isset($monthly['freechatTime']) ? $monthly['freechatTime'] : 0 ?>],
        ['Group', <?= isset($monthly['groupTime']) ? $monthly['groupTime'] : 0 ?>],
        ['Private', <?= isset($monthly['privateTime']) ? $monthly['privateTime'] : 0 ?>]
    ]);

    /* Stacked bar chart with daily info */
    var data2 = google.visualization.arrayToDataTable([
        ['Status', 'Freechat', 'Private', 'Group', 'Away', { role: 'annotation' }],
        <?php foreach ($daily as $d): ?>
        ['<?= $d['dayOrd'] ?>', <?= isset($d['freechatTime']) ? $d['freechatTime']/3600 : 0 ?>, <?= isset($d['privateTime']) ? $d['privateTime']/3600 : 0 ?>, <?= isset($d['groupTime']) ? $d['groupTime']/3600 : 0 ?>, <?= isset($d['awayTime']) ? $d['awayTime']/3600 : 0 ?>, ''],
        <?php endforeach; ?>
    ]);

    var options2 = {
        legend: { position: 'top', maxLines: 3 },
        bar: { groupWidth: '75%' },
        isStacked: true,
        responsive: true,
        maintainAspectRatio: false,
        backgroundColor: '<?= isset($chartcolor) ? $chartcolor : '#ffffff' ?>',
        titleTextStyle: {
            color: '<?= isset($chartTextcolor) ? $chartTextcolor : '#000000' ?>'
        },
        hAxis: {
            textStyle: {
                color: '<?= isset($chartTextcolor) ? $chartTextcolor : '#000000' ?>'
            }
        },
        vAxis: {
            textStyle: {
                color: '<?= isset($chartTextcolor) ? $chartTextcolor : '#000000' ?>'
            }
        }
    };

    // Check if the chart already exists
    if (isChartDrawn) {
        document.getElementById('dailychart').innerHTML = ''; // Clear existing chart
    }
    
    var chart2 = new google.visualization.ColumnChart(document.getElementById('dailychart'));
    chart2.draw(data2, options2);
    isChartDrawn = true; // Set the flag to indicate the chart is drawn

    /* Timeline chart */
    var colorMap = {
        'freechat': '#3366cc',
        'private': '#dc3912',
        'members': 'purple',
        'away': '#109618',
        'offline': 'white'
    };

    var chart3 = new google.visualization.Timeline(document.getElementById('timelinechart'));
    var data3 = new google.visualization.DataTable();

    data3.addColumn({ type: 'string', id: 'Position' });
    data3.addColumn({ type: 'string', id: 'Name' });
    data3.addColumn({ type: 'string', role: 'style' });
    data3.addColumn({ type: 'date', id: 'Start' });
    data3.addColumn({ type: 'date', id: 'End' });

    data3.addRows([
        <?php foreach ($history as $h): ?>
            <?php
            if ($h['status'] == 'f') $h['status'] = 'Freechat Show';
            if ($h['status'] == 'o') $h['status'] = 'Offline';
            if ($h['status'] == 'p') $h['status'] = 'Private Show';
            if ($h['status'] == 'g') $h['status'] = 'Group Show';
            ?>
            ['<?= $h['day'] ?>', '<?= ucfirst($model['nickname']) ?> <?= $h['status'] ?>', colorMap['<?= $h['status'] ?>'], new Date(<?= isset($h['epochTime']) ? $h['epochTime'] * 1000 : 0 ?>), new Date(<?= isset($h['epochTime']) && isset($h['statusTime']) ? ($h['epochTime'] + $h['statusTime']) * 1000 : 0 ?>)],
        <?php endforeach; ?>
    ]);

    var options3 = {
        backgroundColor: '<?= isset($chartcolor) ? $chartcolor : '#ffffff' ?>',
        height: <?= isset($daysinmonth) ? $daysinmonth * 25 + 50 : 500 ?>,
        responsive: true,
        maintainAspectRatio: true,
        timeline: { showBarLabels: false, hAxis: { color: '#111' } },
        avoidOverlappingGridLines: false,
        legend: { position: 'top', maxLines: 4 },
        hAxis: { color: '#111' },
        hAxis: {
            minValue: new Date(<?= isset($startEpoch) ? $startEpoch : 0 ?> * 1000),
            maxValue: new Date(<?= isset($startEpoch) ? $startEpoch : 0 ?> * 1000)
        },
        titleTextStyle: {
            color: '<?= isset($chartTextcolor) ? $chartTextcolor : '#000000' ?>'
        },
        hAxis: {
            textStyle: {
                color: '<?= isset($chartTextcolor) ? $chartTextcolor : '#000000' ?>'
            }
        },
        vAxis: {
            textStyle: {
                color: '<?= isset($chartTextcolor) ? $chartTextcolor : '#000000' ?>'
            }
        }
    };

    // Change xAxis to labels to white
    google.visualization.events.addListener(chart3, 'ready', function () {
        var labels = document.getElementById('timelinechart').getElementsByTagName('text');
        Array.prototype.forEach.call(labels, function(label) {
            if (label.getAttribute('text-anchor') === 'middle') {
                label.setAttribute('fill', '#c1c1c1');
            }
        });
    });

    chart3.draw(data3, options3);
}
</script>
